﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Runtime.CompilerServices

Namespace IsCheckedBinding
    Public Class MyViewModel
        Implements INotifyPropertyChanged

        Private Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
        Private pClubs As ObservableCollection(Of Club)
        Private pPlayers As ObservableCollection(Of Player)
        Private pSelectedItem As Object

        Public ReadOnly Property Clubs() As ObservableCollection(Of Club)
            Get
                If Me.pClubs Is Nothing Then
                    Me.pClubs = Club.GetClubs()
                End If

                Return Me.pClubs
            End Get
        End Property

        Public ReadOnly Property Players() As ObservableCollection(Of Player)
            Get
                If Me.pPlayers Is Nothing Then
                    Me.pPlayers = Player.GetPlayers()
                End If

                Return Me.pPlayers
            End Get
        End Property

        Public Property SelectedItem() As Object
            Get
                Return Me.pSelectedItem
            End Get
            Set
                If Value <> Me.SelectedItem Then
                    Me.pSelectedItem = Value
                    Me.OnPropertyChanged("SelectedItem")
                End If
            End Set
        End Property

        Private Sub OnPropertyChanged(<CallerMemberName()> Optional ByVal propertyName As String = Nothing)
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
        End Sub
    End Class
End Namespace